import w from "axios";
function g(i, t, o, e, n, a, p, d) {
  var s = typeof i == "function" ? i.options : i;
  t && (s.render = t, s.staticRenderFns = o, s._compiled = !0), e && (s.functional = !0), a && (s._scopeId = "data-v-" + a);
  var r;
  if (p ? (r = function(l) {
    l = l || // cached call
    this.$vnode && this.$vnode.ssrContext || // stateful
    this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext, !l && typeof __VUE_SSR_CONTEXT__ < "u" && (l = __VUE_SSR_CONTEXT__), n && n.call(this, l), l && l._registeredComponents && l._registeredComponents.add(p);
  }, s._ssrRegister = r) : n && (r = d ? function() {
    n.call(
      this,
      (s.functional ? this.parent : this).$root.$options.shadowRoot
    );
  } : n), r)
    if (s.functional) {
      s._injectStyles = r;
      var u = s.render;
      s.render = function(_, c) {
        return r.call(c), u(_, c);
      };
    } else {
      var h = s.beforeCreate;
      s.beforeCreate = h ? [].concat(h, r) : [r];
    }
  return {
    exports: i,
    options: s
  };
}
const m = {
  name: "IPHighlighter",
  props: {
    apiUrl: {
      type: String,
      default: "https://ydworkflow-langchain.site.youdao.com/webhook/8fd29a49-e4cc-4ca8-b904-df46fee3b650"
    },
    requestConfig: {
      type: Object,
      default: () => ({
        credentials: "include",
        headers: {}
      })
    }
  },
  data() {
    return {
      tooltipRef: null,
      showTooltip: !1,
      currentIP: null,
      ipInfo: null,
      tooltipStyle: {
        left: "0px",
        top: "0px",
        zIndex: 1e4
      },
      ipRegex: /\b(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b/g
    };
  },
  mounted() {
    document.addEventListener("click", this.handleClickOutside), document.addEventListener("keydown", this.handleKeyDown);
  },
  beforeDestroy() {
    document.removeEventListener("click", this.handleClickOutside), document.removeEventListener("keydown", this.handleKeyDown);
  },
  watch: {
    ipInfo(i) {
      i ? this.showTooltip = !0 : this.showTooltip = !1;
    },
    showTooltip(i) {
      i || (this.currentIP = null, this.ipInfo = null);
    }
  },
  methods: {
    handleMouseUp(i) {
      var e;
      if ((e = this.$refs.tooltip) != null && e.contains(i.target))
        return;
      const t = window.getSelection(), o = t.toString().trim();
      if (o)
        if (o.match(this.ipRegex)) {
          const a = t.getRangeAt(0).getBoundingClientRect();
          this.currentIP = o, this.updateTooltipPosition({
            pageX: a.left + window.scrollX,
            pageY: a.bottom + window.scrollY
          }), this.showIPInfo(o, i);
        } else
          this.closeTooltip();
    },
    async showIPInfo(i, t) {
      this.currentIP = i, this.ipInfo = null, this.showTooltip = !1;
      try {
        const o = await w.get(`${this.apiUrl}`, {
          params: {
            ip: i,
            message: `请查询IP: ${i} 的详细信息`
          },
          ...this.requestConfig
        });
        this.ipInfo = o.data.data || null, this.showTooltip = !0;
      } catch {
        this.ipInfo = null, this.showTooltip = !1;
      }
    },
    updateTooltipPosition(i) {
      const t = window.innerWidth, o = window.innerHeight;
      let e = i.pageX, n = i.pageY + 10;
      e + 300 > t && (e = t - 310), n + 200 > o && (n = i.pageY - 210), e = Math.max(10, e), n = Math.max(10, n);
      const a = {
        left: `${e}px`,
        top: `${n}px`,
        zIndex: 2147483647,
        position: "fixed",
        display: "block",
        visibility: "visible",
        opacity: 1
      };
      this.tooltipStyle = a;
    },
    handleClickOutside(i) {
      var t;
      (t = this.$refs.tooltip) != null && t.contains(i.target) || this.closeTooltip();
    },
    handleKeyDown(i) {
      i.key === "Escape" && this.showTooltip && this.closeTooltip();
    },
    closeTooltip() {
      this.showTooltip = !1, this.currentIP = null, this.ipInfo = null, this.$nextTick(() => {
        this.currentIP = null, this.ipInfo = null;
      });
    },
    formatValue(i) {
      if (i == null)
        return "N/A";
      const t = String(i), o = /https?:\/\/(www\.)?[-a-zA-Z0-9@:%._\+~#=]{1,256}\.[a-zA-Z0-9()]{1,6}\b([-a-zA-Z0-9()@:%_\+.~#?&//=]*)/gi;
      return typeof i == "object" ? Array.isArray(i) ? i.map((e) => this.formatValue(e)).join(", ") || "N/A" : Object.entries(i).map(([e, n]) => `${e}: ${this.formatValue(n)}`).join(", ") || "N/A" : t.match(o) ? `<a href="${t}" target="_blank" class="ip-tooltip-link">${t}</a>` : t;
    }
  }
};
var v = function() {
  var t = this, o = t._self._c;
  return o("div", { staticClass: "ip-highlighter", on: { mouseup: t.handleMouseUp } }, [t._t("default"), o("div", { directives: [{ name: "show", rawName: "v-show", value: t.showTooltip && t.ipInfo, expression: "showTooltip && ipInfo" }], ref: "tooltip", staticClass: "el-popover el-popper ip-tooltip", style: t.tooltipStyle, on: { mousedown: function(e) {
    e.stopPropagation();
  } } }, [o("div", { staticClass: "ip-tooltip-close", on: { click: function(e) {
    return e.stopPropagation(), t.closeTooltip.apply(null, arguments);
  } } }, [t._v("×")]), o("div", { staticClass: "popper__arrow" }), o("div", { staticClass: "ip-tooltip-header" }, [o("h3", { staticClass: "ip-tooltip-title" }, [t._v("IP: " + t._s(t.ipInfo && t.ipInfo.ip))])]), o("div", { staticClass: "ip-tooltip-content" }, [t.ipInfo ? t._l(t.ipInfo, function(e, n) {
    return o("div", { key: n, staticClass: "ip-tooltip-row" }, [o("div", { staticClass: "ip-tooltip-key" }, [t._v(t._s(n) + ":")]), o("div", { staticClass: "ip-tooltip-value", domProps: { innerHTML: t._s(t.formatValue(e)) } })]);
  }) : o("div", { staticClass: "ip-tooltip-row" }, [t._v("加载中...")])], 2)])], 2);
}, I = [], y = /* @__PURE__ */ g(
  m,
  v,
  I,
  !1,
  null,
  null,
  null,
  null
);
const C = y.exports, f = function(i) {
  i.component("IPHighlighter", C);
};
typeof window < "u" && window.Vue && f(window.Vue);
const P = {
  install: f
};
export {
  C as IPHighlighter,
  P as default
};
